Find the smallest element greater than current element











up vote
3
down vote

favorite












my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.










share|cite|improve this question









New contributor




Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.




















  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    5 hours ago










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    3 hours ago












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    6 mins ago















up vote
3
down vote

favorite












my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.










share|cite|improve this question









New contributor




Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.




















  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    5 hours ago










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    3 hours ago












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    6 mins ago













up vote
3
down vote

favorite









up vote
3
down vote

favorite











my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.










share|cite|improve this question









New contributor




Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.











my question is that given a list of integers (lets say A), for each element A[i], find the smallest element A[j] which could satisfy A[i] < A[j] and i < j. Return -1 if there is no such element.



For example, given [4,2,1,9,3], return [9,3,3,-1,-1]



I have come up with a brute force solution which costs $O(n^2)$, but I'm wondering if there could be a more efficient solution.







algorithms arrays






share|cite|improve this question









New contributor




Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.











share|cite|improve this question









New contributor




Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









share|cite|improve this question




share|cite|improve this question








edited 36 mins ago









xskxzr

3,3871730




3,3871730






New contributor




Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









asked 5 hours ago









Austin

161




161




New contributor




Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.





New contributor





Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.






Austin is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.












  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    5 hours ago










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    3 hours ago












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    6 mins ago


















  • How difficult would this problem be if you had an array of integers, sorted in ascending order?
    – gnasher729
    5 hours ago










  • I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
    – xuq01
    3 hours ago












  • I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
    – xuq01
    6 mins ago
















How difficult would this problem be if you had an array of integers, sorted in ascending order?
– gnasher729
5 hours ago




How difficult would this problem be if you had an array of integers, sorted in ascending order?
– gnasher729
5 hours ago












I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
– xuq01
3 hours ago






I believe that this could be done in as little as O(n)! I'll elaborate when I have access to a computer.
– xuq01
3 hours ago














I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
– xuq01
6 mins ago




I think my solution is wrong; the minimum time complexity must be O(n log n) I think.
– xuq01
6 mins ago










1 Answer
1






active

oldest

votes

















up vote
2
down vote













A better solution would be using a balanced binary search tree.

You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






share|cite|improve this answer























    Your Answer





    StackExchange.ifUsing("editor", function () {
    return StackExchange.using("mathjaxEditing", function () {
    StackExchange.MarkdownEditor.creationCallbacks.add(function (editor, postfix) {
    StackExchange.mathjaxEditing.prepareWmdForMathJax(editor, postfix, [["$", "$"], ["\\(","\\)"]]);
    });
    });
    }, "mathjax-editing");

    StackExchange.ready(function() {
    var channelOptions = {
    tags: "".split(" "),
    id: "419"
    };
    initTagRenderer("".split(" "), "".split(" "), channelOptions);

    StackExchange.using("externalEditor", function() {
    // Have to fire editor after snippets, if snippets enabled
    if (StackExchange.settings.snippets.snippetsEnabled) {
    StackExchange.using("snippets", function() {
    createEditor();
    });
    }
    else {
    createEditor();
    }
    });

    function createEditor() {
    StackExchange.prepareEditor({
    heartbeatType: 'answer',
    autoActivateHeartbeat: false,
    convertImagesToLinks: false,
    noModals: true,
    showLowRepImageUploadWarning: true,
    reputationToPostImages: null,
    bindNavPrevention: true,
    postfix: "",
    imageUploader: {
    brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
    contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
    allowUrls: true
    },
    onDemand: true,
    discardSelector: ".discard-answer"
    ,immediatelyShowMarkdownHelp:true
    });


    }
    });






    Austin is a new contributor. Be nice, and check out our Code of Conduct.










    draft saved

    draft discarded


















    StackExchange.ready(
    function () {
    StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcs.stackexchange.com%2fquestions%2f101806%2ffind-the-smallest-element-greater-than-current-element%23new-answer', 'question_page');
    }
    );

    Post as a guest















    Required, but never shown

























    1 Answer
    1






    active

    oldest

    votes








    1 Answer
    1






    active

    oldest

    votes









    active

    oldest

    votes






    active

    oldest

    votes








    up vote
    2
    down vote













    A better solution would be using a balanced binary search tree.

    You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

    Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






    share|cite|improve this answer



























      up vote
      2
      down vote













      A better solution would be using a balanced binary search tree.

      You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

      Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






      share|cite|improve this answer

























        up vote
        2
        down vote










        up vote
        2
        down vote









        A better solution would be using a balanced binary search tree.

        You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

        Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.






        share|cite|improve this answer














        A better solution would be using a balanced binary search tree.

        You can process the elements from the right to left and for each element you find the vertex in the tree with the smallest key greater than this element (a search query on the tree suffice) and then you add the element to the tree.

        Total complexity is $O(nlog(n))$ since we are iterating over the elements once and having one query and one insert operations in each iteration.







        share|cite|improve this answer














        share|cite|improve this answer



        share|cite|improve this answer








        edited 4 hours ago

























        answered 5 hours ago









        narek Bojikian

        3316




        3316






















            Austin is a new contributor. Be nice, and check out our Code of Conduct.










            draft saved

            draft discarded


















            Austin is a new contributor. Be nice, and check out our Code of Conduct.













            Austin is a new contributor. Be nice, and check out our Code of Conduct.












            Austin is a new contributor. Be nice, and check out our Code of Conduct.
















            Thanks for contributing an answer to Computer Science Stack Exchange!


            • Please be sure to answer the question. Provide details and share your research!

            But avoid



            • Asking for help, clarification, or responding to other answers.

            • Making statements based on opinion; back them up with references or personal experience.


            Use MathJax to format equations. MathJax reference.


            To learn more, see our tips on writing great answers.





            Some of your past answers have not been well-received, and you're in danger of being blocked from answering.


            Please pay close attention to the following guidance:


            • Please be sure to answer the question. Provide details and share your research!

            But avoid



            • Asking for help, clarification, or responding to other answers.

            • Making statements based on opinion; back them up with references or personal experience.


            To learn more, see our tips on writing great answers.




            draft saved


            draft discarded














            StackExchange.ready(
            function () {
            StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2fcs.stackexchange.com%2fquestions%2f101806%2ffind-the-smallest-element-greater-than-current-element%23new-answer', 'question_page');
            }
            );

            Post as a guest















            Required, but never shown





















































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown

































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown







            Popular posts from this blog

            サソリ

            広島県道265号伴広島線

            Setup Asymptote in Texstudio